/* This small piece of code shows how to access sequoia from PHP. It
 * has been successfully tested with gcc 3.3, PHP4 and PHP5 and
 * apache2.

 * Its only purpose is to demonstrate feasibility; to be a quick and
 * dirty sketch of what such a carob/PHP module could be. As such, it
 * is thread-unsafe, Unicode-unsafe, probably leaks memory, and surely
 * much more and worst. Do not use this code for any serious work.

 * The generated module can be installed with something like this:

 cp carob/contrib/PHP/.libs/carob.so /usr/lib/php4/20020429/

 * Then tested like this: test -f test_carob_read.php
 * Don't forget to add the module to your php.ini file.
 * Don't forget to stop & start your apache2 server each time you reinstall
 * a fresh PHP module.

 -- Marc Herbert. */

#include <sstream>
#include <vector>

// needed for kill(2) (to attach & debug)
#include <sys/types.h>
#include <signal.h>
#include "php_carob.h"

#include "../../include/Connection.hpp"
#include "../../include/DriverResultSet.hpp"
#include "../../include/Statement.hpp"

using namespace CarobNS;

#define STRINGIFY(a)    #a
#define STRINGIFY2(a)   STRINGIFY(a)
#define LINESTR         STRINGIFY2(__LINE__)


static function_entry carob_functions[] = {
  PHP_FE(carob_read, NULL)
  {NULL, NULL, NULL}
};

zend_module_entry carob_module_entry = {
#if ZEND_MODULE_API_NO >= 20010901
  STANDARD_MODULE_HEADER,
#endif
  PHP_CAROB_EXTNAME,
  carob_functions,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
#if ZEND_MODULE_API_NO >= 20010901
  PHP_CAROB_VERSION,
#endif
  STANDARD_MODULE_PROPERTIES
};

extern "C" { // needed cause missing in PHP4
#ifdef COMPILE_DL_CAROB
  ZEND_GET_MODULE(carob)
#endif
    }



/* Converts wstring to string */
static void ws2s (const std::wstring& fromws, std::string& tos)
{
  // worst worst case is 4, "usual" worst case is only 3?
  int tempsize = 4*fromws.length();
  char *temps = new char[tempsize];
		// thread-unsafe
  wcstombs(temps, fromws.c_str(), tempsize-1);
  tos = temps;
  delete temps;
}

/* Converts string to wstring */
static void s2ws (const std::string& froms, std::wstring& tows)
{
  // worst case is 1
  int tempsize = froms.length();
  wchar_t *tempws = new wchar_t[tempsize];
		// thread-unsafe
  mbstowcs(tempws, froms.c_str(), tempsize-1);
  tows = tempws;
  delete tempws;
}



PHP_FUNCTION(carob_read)
{
  
  // uncomment to stop, attach & debug
  // kill(0, SIGTSTP);
  std::vector<ControllerInfo> ctrls;
  ctrls.push_back(ControllerInfo(L"localhost", 25322));
  ConnectionParameters connectionPrms(ctrls,
                                      L"myDB",
                                      L"user",
                                      L"");  
  try
  {
    char *req;
    int req_len; // ignored: we just don't handle inline zeros.
       
    // Exception test
    // throw CarobException(L"test1");

    // Get request string
    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s", &req, &req_len) == FAILURE) {
      throw CarobException(L"could not get request string");
    }

    std::string temps(req);
    std::wstring wreq;
    s2ws(temps, wreq);


    // Connect to controller
    Connection connection(connectionPrms);

    // Create a statement
    Statement* statementPtr = connection.createStatement();
    DriverResultSet* drsPtr = statementPtr->executeQuery(wreq);

    if (!drsPtr)
      throw CarobException(L"null resultset");

    // Pull out resultset
    // optional output stream, to use instead of php_printf()
    // std::ostringstream resultset;

    int i = 0;
    while (drsPtr->next())
      //      for (int i=0; i<5; i++) // TODO: put a while loop in here
    {
      i++;

      std::wostringstream wide_oss;
    
#define WTABBING L"<TD>"

      wide_oss << L"<TR>" << WTABBING << i << WTABBING << drsPtr->getInt32(1)
                          << WTABBING << drsPtr->getString(2)
                          << WTABBING << drsPtr->getString(3) << std::endl;

      std::string narrow_row;
      ws2s(wide_oss.str().c_str(), narrow_row);

      php_printf(narrow_row.c_str());
      // resultset << narrow_row;

    }

    // RETURN_STRING(const_cast<char *>(resultset.str().c_str()), 1);

  }
  catch (const CarobException& e)
  {
    std::string temps("Catched CarobException at " __FILE__ ":" LINESTR" \n");
    std::string narrowdesc;
    ws2s(e.description(), narrowdesc);
    temps += narrowdesc;
    temps += "\n";
      
    php_printf(temps.c_str());
    // RETURN_STRING(const_cast<char *>(temps.c_str()), 1);
  }
  catch (...)
  {
    php_printf("Unknown exception at " __FILE__ ":" LINESTR  "\n");
    // RETURN_STRING("Unknown exception at " __FILE__ ":" LINESTR  "\n", 1);
  }
}

/*
 * Local Variables:
 * c-file-style: "bsd"
 * c-basic-offset: 2
 * indent-tabs-mode: nil
 * End:
 */
